{ (C) Simon C Horton 1995 - 1996 }

{ OCT 97 - Release Notes                                         }
{ The Main BBS core file where all the units are linked into     }

{$M 16384,0,10000}
    {4000 return when complie }

Program SBBS;

Uses Dos, Crt, Lib, Data, Start, Fossil, Sf2U, Stats, ErrorLog, Wins, LockUser;

{$L MSCR.OBJ }

procedure MainScreen; external;
procedure MainScreen_Width; external;
procedure MainScreen_Depth; external;
procedure MainScreen_Length; external;

procedure ResetSystem;
Var
  FileMask,
  DeleteEntry,
  Number   : String;
  DirInfo  : SearchRec;
  F        : file;
begin
  { Delete All User Temp Files }
  Str(UserNumber, Number);
  If BBSCfg.TempDir[Length(BBSCfg.TempDir)] = '\' then
    begin
      FileMask := BBSCfg.TempDir + Number + '.*';
    end
  Else
    begin
      FileMask := BBSCfg.TempDir + '\' + Number + '.*';
    end;
  FindFirst(FileMask, AnyFile, DirInfo);
  While DosError = 0 do
   begin
     If BBSCfg.TempDir[Length(BBSCfg.TempDir)] = '\' then
       begin
           DeleteEntry := BBSCfg.TempDir + DirInfo.Name;
        end
     Else
        begin
            DeleteEntry := BBSCfg.TempDir + '\' + Dirinfo.Name;
        end;
     If Pos('.TAG', DirInfo.Name) = 0 then   { Skip Tag File }
       begin
         {$I-} Assign(F, DeleteEntry);
         Reset(F); {I$+}
         FileError := IOResult;
         If FileError <> 0 then
          begin
            LogError('Unable Delete User File ' + DeleteEntry + ' - ' + ErrorString(FileError));
          end
        Else
          begin
            Close(F);
            Erase(F);
            LogError('UserFile ' + DeleteEntry + ' Succesfully Deleted');
          end;
        end;
      FindNext(DirInfo);
   end;
   If (BBSCfg.Node > 0) then { If Running MultiNode Remove Node Files }
    begin
      CheckLockFile;
    end;
end;

procedure BeginBBS;
Var
  Rec, Code : Integer;
begin
   ScriptFile    := 'LOGON.SFI';
   SessionLength := 0;
   Rec           := 0;
   { If Running MultiNode Remove Any Undeleted Lock Files }
    If (BBSCfg.Node > 0) then
    begin
      CheckLockFile;
    end;
   Case UserInfo.UserLevel of
       1 : SessionTime := BBSCfg.L1T;
       2 : SessionTime := BBSCfg.L2T;
       3 : SessionTime := BBSCfg.L3T;
       4 : SessionTime := BBSCfg.L4T;
       5 : SessionTime := BBSCfg.L5T;
       6 : SessionTime := BBSCfg.L6T;
       7 : SessionTime := BBSCfg.L7T;
       8 : SessionTime := BBSCfg.L8T;
       9 : SessionTime := BBSCfg.L9T;
     Else
       SessionTime := 9999;
   end; { Case End }
   Repeat
     Sfi(Scriptfile);
   until Scriptfile = 'end';
end;

Var
  I,
  OrgMode  : Integer;
  CmdLine  : String[30];
  GetLine  : string;
Begin
  Local  := False;
  OnLine := False;
  SOnOff := True;
  CmdLine := '';
  GetLine := '';
  for i := 1 to ParamCount do
     CmdLine := CmdLine + ParamStr(i);
  For i := 1 to length(cmdLine) do
      CmdLine[i] := UpCase(CmdLine[i]);
  If Pos('/?', CmdLine) > 0 then
    begin
      ClrScr;
      Writeln('Type SAURON < Switch > [ENTER] To Start BBS......');
      Writeln;
      Writeln('Valid Switches :- ');
      Writeln;
      Writeln('               /LOCAL             Start Sauron Beta In Local Mode ');
      Writeln('               /C:<filename.ext>  Use Alternat Configuration File ');
      Writeln('               /D                 MailDoor Mode < Unsure How I did it');
      Writeln;
      Halt(0);
    end;
  If Pos('/LOCAL', CmdLine) > 0 Then Local := True;
  If Pos('/C:', CmdLine) > 0 then
    begin
      I := Pos('/C:', CmdLine) + 3;
      repeat
        GetLine := GetLine + CmdLine[i];
        inc(i);
      until (Cmdline[i] = '/') or (i = length(CmdLine) + 1);
      ConfigFile := Getline;
    end;
  Finish := False;
  DirectVideo := False;
  TextBackGround(Black);
  ClrScr;
  Repeat
    If Online then Local := False;
    OrgMode := LastMode; { Store PowerUp TextMode }
    If (not Local) and (Paramstr(1) <> '/D') then
      begin
        Window(1,1,80,25);
        Move (pointer(@MainScreen)^,Ptr($B800,0)^,4000);
       end;
    StartBBS;
    If Not Finish then
      begin
        BeginBBS;
        If Paramstr(1) = '/D' then Finish := True;
      end;
    ResetSystem;
    CloseDataFiles;
    If Not Local then
      begin
        PurgeInput;
        FlushOutput;
      end;
  Until Finish = True;
  ClrScr;
  Halt(1);
end.

